// Package rhyzome provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package rhyzome

import (
	"fmt"
	"net/http"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/labstack/echo/v4"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (GET /.well-known/rhyzome/ca.pem)
	ProvisioningCaPem(ctx echo.Context) error

	// (GET /.well-known/rhyzome/provisioning.json)
	ProvisioningInfo(ctx echo.Context) error

	// (GET /v0/instance)
	ListAllInstances(ctx echo.Context) error

	// (POST /v0/instance)
	CreateInstance(ctx echo.Context) error

	// (DELETE /v0/instance/{id})
	DeleteInstance(ctx echo.Context, id string) error

	// (GET /v0/instance/{id})
	GetInstance(ctx echo.Context, id string) error

	// (POST /v0/instance/{id}/start)
	StartInstance(ctx echo.Context, id string) error

	// (POST /v0/instance/{id}/stop)
	StopInstance(ctx echo.Context, id string) error

	// (GET /v0/jobs/{id})
	GetJob(ctx echo.Context, id string) error

	// (GET /v0/jobs/{id}/stream)
	StreamJob(ctx echo.Context, id string) error

	// (GET /v0/network)
	ListAllNetworks(ctx echo.Context) error

	// (POST /v0/network)
	CreateNetwork(ctx echo.Context) error

	// (DELETE /v0/network/{id})
	DeleteNetwork(ctx echo.Context, id string) error

	// (GET /v0/network/{id})
	GetNetwork(ctx echo.Context, id string) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// ProvisioningCaPem converts echo context to params.
func (w *ServerInterfaceWrapper) ProvisioningCaPem(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.ProvisioningCaPem(ctx)
	return err
}

// ProvisioningInfo converts echo context to params.
func (w *ServerInterfaceWrapper) ProvisioningInfo(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.ProvisioningInfo(ctx)
	return err
}

// ListAllInstances converts echo context to params.
func (w *ServerInterfaceWrapper) ListAllInstances(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.ListAllInstances(ctx)
	return err
}

// CreateInstance converts echo context to params.
func (w *ServerInterfaceWrapper) CreateInstance(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.CreateInstance(ctx)
	return err
}

// DeleteInstance converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteInstance(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteInstance(ctx, id)
	return err
}

// GetInstance converts echo context to params.
func (w *ServerInterfaceWrapper) GetInstance(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetInstance(ctx, id)
	return err
}

// StartInstance converts echo context to params.
func (w *ServerInterfaceWrapper) StartInstance(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.StartInstance(ctx, id)
	return err
}

// StopInstance converts echo context to params.
func (w *ServerInterfaceWrapper) StopInstance(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.StopInstance(ctx, id)
	return err
}

// GetJob converts echo context to params.
func (w *ServerInterfaceWrapper) GetJob(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetJob(ctx, id)
	return err
}

// StreamJob converts echo context to params.
func (w *ServerInterfaceWrapper) StreamJob(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.StreamJob(ctx, id)
	return err
}

// ListAllNetworks converts echo context to params.
func (w *ServerInterfaceWrapper) ListAllNetworks(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.ListAllNetworks(ctx)
	return err
}

// CreateNetwork converts echo context to params.
func (w *ServerInterfaceWrapper) CreateNetwork(ctx echo.Context) error {
	var err error

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.CreateNetwork(ctx)
	return err
}

// DeleteNetwork converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteNetwork(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteNetwork(ctx, id)
	return err
}

// GetNetwork converts echo context to params.
func (w *ServerInterfaceWrapper) GetNetwork(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetNetwork(ctx, id)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/.well-known/rhyzome/ca.pem", wrapper.ProvisioningCaPem)
	router.GET(baseURL+"/.well-known/rhyzome/provisioning.json", wrapper.ProvisioningInfo)
	router.GET(baseURL+"/v0/instance", wrapper.ListAllInstances)
	router.POST(baseURL+"/v0/instance", wrapper.CreateInstance)
	router.DELETE(baseURL+"/v0/instance/:id", wrapper.DeleteInstance)
	router.GET(baseURL+"/v0/instance/:id", wrapper.GetInstance)
	router.POST(baseURL+"/v0/instance/:id/start", wrapper.StartInstance)
	router.POST(baseURL+"/v0/instance/:id/stop", wrapper.StopInstance)
	router.GET(baseURL+"/v0/jobs/:id", wrapper.GetJob)
	router.GET(baseURL+"/v0/jobs/:id/stream", wrapper.StreamJob)
	router.GET(baseURL+"/v0/network", wrapper.ListAllNetworks)
	router.POST(baseURL+"/v0/network", wrapper.CreateNetwork)
	router.DELETE(baseURL+"/v0/network/:id", wrapper.DeleteNetwork)
	router.GET(baseURL+"/v0/network/:id", wrapper.GetNetwork)

}
